/*
 * ============================================================================
 * Licensed Materials - Property of IBM
 *  WebSphere sMash
 *
 * (C) Copyright IBM Corp. 2007,2008  All Rights Reserved.
 *
 * US Government Users Restricted Rights - Use, duplication or disclosure
 * restricted by GSA ADP Schedule Contract with IBM Corp.
 * ============================================================================
 */
dojo.provide("zero.ide.widget.debug.DebugGutterMenu");

dojo.require("dijit.Menu");

dojo.declare(
    "zero.ide.widget.debug.DebugGutterMenu",
    [dijit.Menu],
{
    disableCommand: null,
    enableCommand: null,
    clearCommand: null,
    setCommand: null,
    debugView: null,
    line: null,
    
    addEnableCommand: function(menuItem) {
    	this.enableCommand = menuItem;
    	this.addChild(menuItem);
    },
    
    addDisableCommand: function(menuItem) {
    	this.disableCommand = menuItem;
    	this.addChild(menuItem);
    },
    
    addClearCommand: function(menuItem) {
    	this.clearCommand = menuItem;
    	this.addChild(menuItem);
    },
    
    addSetCommand: function(menuItem) {
    	this.setCommand = menuItem;
    	this.addChild(menuItem);
    },
    
    setCodeViewerWidget: function(dv) {
    	this.debugView = dv;
    },    	
    
    _openMyself: function(/*Event*/ evt) {    	
    	this.line = this.debugView.codeViewerWidget.getSourceLine(evt.clientY);
    	var sourcePath = this.debugView.getRelativeSourcePath(this.debugView.codeViewerWidget.filePath);
    	if(this.debugView.isBreakpointSet(sourcePath,this.line)) {
    		// disable the set breakpoint command
    		if(this.setCommand!=null) {
    			this.setCommand.attr('disabled',true);
    			//this.setCommand.setDisabled(true);
    		}
    		if(this.clearCommand!=null) {
    			this.clearCommand.attr('disabled',false);
    			//this.clearCommand.setDisabled(false);
    		}
    		if(this.debugView.isBreakpointEnabled(sourcePath,this.line)) {
    			// disable the enable breakpoint command
    			if(this.enableCommand!=null) {
        			this.enableCommand.attr('disabled',true);
        			//this.enableCommand.setDisabled(true);
        		}
    			if(this.disableCommand!=null) {
        			this.disableCommand.attr('disabled',false);
        			//this.disableCommand.setDisabled(false);
        		}
    		} else {
    			// disable the disable breakpoint command
    			if(this.disableCommand!=null) {
    				this.disableCommand.attr('disabled',true);
    				//this.disableCommand.setDisabled(true);
        		}
    			if(this.enableCommand!=null) {
        			this.enableCommand.attr('disabled',false);
        			//this.enableCommand.setDisabled(false);
        		}
    		}
    	} else {    		
    		// disable all commands except set 
    		if(this.setCommand!=null) {
    			// only allow set if the line is an executable
    			if(this.debugView.canSetBreakpointOnLine(this.line)) {
    				this.setCommand.attr('disabled',false);
    				//this.setCommand.setDisabled(false);
    			} else {
    				this.setCommand.attr('disabled',true);
    				//this.setCommand.setDisabled(true);
    			}
    		}
    		if(this.clearCommand!=null) {
				this.clearCommand.attr('disabled',true);
				//this.clearCommand.setDisabled(true);
    		}
    		if(this.enableCommand!=null) {
				this.enableCommand.attr('disabled',true);
				//this.enableCommand.setDisabled(true);
    		}
    		if(this.disableCommand!=null) {
				this.disableCommand.attr('disabled',true);
				//this.disableCommand.setDisabled(true);
    		}   		
    	}    	
    	this.inherited('_openMyself', arguments);    	
	}
});
